-- $Name: Волшебники и Камень$
-- $Version: 0.04$
-- $Author: Irremann$

require 'fmt' -- некоторые функции форматирования
fmt.para = true -- включить режим параграфов (отступы)
require 'noinv'
require 'snd'
require 'cutscene'

game.act = 'Не работает.';
game.use = 'Это не поможет.';
game.inv = 'Зачем мне это?';

global { -- определение глобальных переменных
	name = '';
	alignment = '';
	class = '';
	kind = '';
	attribute = '';
	weapon = '';

	golem = '';
	attribute2 = '';
	weapon2 = '';
	stone = 0;
	die = 0;
	achiv = {};
};

function start()
	std.phrase_show = false
end;

include 'stuff.lua';

-------начало

main = cutscene {
	nam = 'main';
	title = false;
	pic = 'pics/01.png';
	onenter = function()
		snd.music 'snd/The_Bards_Tale.ogg';
	end;
	decor = function()
		p 'В одном далёком королевстве, в самом забытом углу карты, была чёрная гора. Обиталище пивцов крови, кентавров и злобных йети. И случилось так, что боги оставили там Камень Могущества.^[cut]';
		p 'Был ли к этому причастен Бронн, бог лукавства и шутовства или Мендель, бог забывчивости и старческих причуд, смертным не дано познать. Но Камень оказался на самой вершине чёрной горы.^[cut]';
		p 'И не прошло и года, как волшебники во всех двенадцати королевствах прознали про Камень Могущества. Кто гадая по внутренностям сороки, кто смотря в волшебный шар. А некоторые и вовсе благодаря злоупотреблению желтым лотосом.^[cut]';
		p 'И вот волшебники со всех королевств собрались в путь. Долгий и полный всяческих опасностей. Но награда манила их вперёд.^[cut]';
		p '[code walkin "Вопрос"]';
	end;
};

dlg {
	nam = 'Вопрос';
	pic = 'pics/01.png';
	title = false;
	onenter = 'Кто же пришёл к подножию чёрной горы?';
	phr = {
		only = true;
		{'Добрый..', function() name = 'добрый '; alignment = 'добрый'; end, next = '#класс'};
		{'Злой..', function() name = 'злой '; alignment = 'злой'; end, next = '#класс'};
--		{'Циничный..', function() name = 'Циничный '; alignment = 'циничный'; end, next = '#класс'};
		{false, '#класс',
			only = true;
			{'волшебник..', function() name = name..'волшебник '; class = 'волшебник'; end, next = '#имя'};
			{'некромант..', function() name = name..'некромант '; class = 'некромант'; end, next = '#имя'};
			{'друид..', function() name = name..'друид '; class = 'друид'; end, next = '#имя'};
		};
		{false, '#имя',
			only = true;
			{'Курамор', function() name = name..'Курамор'; weapongen(); walk 'Трактир'; end;};
			{'Гулюлюн', function() name = name..'Гулюлюн'; weapongen(); walk 'Трактир'; end;};
			{'Хухур', function() name = name..'Хухур'; weapongen(); walk 'Трактир'; end;};
		};
	};
};

weapongen = function()
	if alignment == 'добрый' then
		if class == 'волшебник' then
			local i = rnd(3);
			if i == 1 then
				weapon = 'свеча';
				kind = 'ж';
			elseif i == 2 then
				weapon = 'палочка';
				kind = 'ж';
			elseif i == 3 then
				weapon = 'посох';
				kind = 'м';
			end;
			i = rnd(3);
			if kind == 'м' then
				if i == 1 then
					attribute = 'Волшебный';
				elseif i == 2 then
					attribute = 'Светящийся';
				elseif i == 3 then
					attribute = 'Электрический';
				end;
			else
				if i == 1 then
					attribute = 'Волшебная';
				elseif i == 2 then
					attribute = 'Светящаяся';
				elseif i == 3 then
					attribute = 'Электрическая';
				end;					
			end;
		elseif class == 'некромант' then
			local i = rnd(3);
			if i == 1 then
				weapon = 'череп';
				kind = 'м';
			elseif i == 2 then
				weapon = 'гримуар';
				kind = 'м';
			elseif i == 3 then
				weapon = 'посох';
				kind = 'м';
			end;
			i = rnd(3);
			if kind == 'м' then
				if i == 1 then
					attribute = 'Волшебный';
				elseif i == 2 then
					attribute = 'Светящийся';
				elseif i == 3 then
					attribute = 'Электрический';
				end;
			end;
		elseif class == 'друид' then
			local i = rnd(3);
			if i == 1 then
				weapon = 'палица';
				kind = 'ж';
			elseif i == 2 then
				weapon = 'дубина';
				kind = 'ж';
			elseif i == 3 then
				weapon = 'моргенштерн';
				kind = 'м';
			end;
			i = rnd(3);
			if kind == 'м' then
				if i == 1 then
					attribute = 'Волшебный';
				elseif i == 2 then
					attribute = 'Светящийся';
				elseif i == 3 then
					attribute = 'Электрический';
				end;
			else
				if i == 1 then
					attribute = 'Волшебная';
				elseif i == 2 then
					attribute = 'Светящаяся';
				elseif i == 3 then
					attribute = 'Электрическая';
				end;					
			end;
		end;
			
	elseif alignment == 'злой' then
		if class == 'волшебник' then
			local i = rnd(3);
			if i == 1 then
				weapon = 'пила';
				kind = 'ж';
			elseif i == 2 then
				weapon = 'меч';
				kind = 'м';
			elseif i == 3 then
				weapon = 'посох';
				kind = 'м';
			end;
			i = rnd(3);
			if kind == 'м' then
				if i == 1 then
					attribute = 'Проклятый';
				elseif i == 2 then
					attribute = 'Отравленный';
				elseif i == 3 then
					attribute = 'Электрический';
				end;
			else
				if i == 1 then
					attribute = 'Проклятая';
				elseif i == 2 then
					attribute = 'Отравленная';
				elseif i == 3 then
					attribute = 'Электрическая';
				end;					
			end;
		elseif class == 'некромант' then
			local i = rnd(3);
			if i == 1 then
				weapon = 'череп';
				kind = 'м';
			elseif i == 2 then
				weapon = 'гримуар';
				kind = 'м';
			elseif i == 3 then
				weapon = 'посох';
				kind = 'м';
			end;
			i = rnd(3);
			if kind == 'м' then
				if i == 1 then
					attribute = 'Проклятый';
				elseif i == 2 then
					attribute = 'Отравленный';
				elseif i == 3 then
					attribute = 'Электрический';
				end;
			end;
		elseif class == 'друид' then
			local i = rnd(3);
			if i == 1 then
				weapon = 'палица';
				kind = 'ж';
			elseif i == 2 then
				weapon = 'пила';
				kind = 'ж';
			elseif i == 3 then
				weapon = 'моргенштерн';
				kind = 'м';
			end;
			i = rnd(3);
			if kind == 'м' then
				if i == 1 then
					attribute = 'Проклятый';
				elseif i == 2 then
					attribute = 'Отравленный';
				elseif i == 3 then
					attribute = 'Электрический';
				end;
			else
				if i == 1 then
					attribute = 'Проклятая';
				elseif i == 2 then
					attribute = 'Отравленная';
				elseif i == 3 then
					attribute = 'Электрическая';
				end;										
			end;
		end;
	end;
end;

room {
	nam = 'Трактир';
	pic = 'pics/02.png';
	title = false;
	onenter = function()
		take 'Оружие';
		p('И вот '..name..' оказался наконец в последнем трактире, что у подножия Чёрной Горы.');
	end;
	dsc = 'В трактире пахнет едой.';
	obj = {'Трактирщик', 'Географист'};
	way = {path {'Наружу', 'Кукурузное поле'}};
};

dlg {
	nam = 'Разговор с трактирщиком';
	pic = 'pics/02.png';
	title = false;
	onenter = function()
		p ('Только '..name..' подошёл к трактирщику, как тот радостно воскликнул: "Это же знаменитый артефакт -- '..attribute..' '..weapon..', я дам за него '..attribute2..' '..weapon2..', согласны?"');
	end;
	phr = {
		{'Согласен.', function() attribute = attribute2; weapon = weapon2; kind = 'м'; p '-- Отлично, отлично.'; walkout(); end;};
		{'Не интересует.', function() p '-- Надумаете меняться, приходите!'; walkout(); end;};
	};
};

dlg {
	nam = 'Разговор с географистом';
	pic = 'pics/02.png';
	title = false;
	onenter = function()
		if visits() == 1 then
			p ('-- Ещё один путник в этих столь отдалённых краях? Я уж думал только мне, известному географисту Сибеллиусу интересен этот медвежий угол. Но моя "табула географика" толкает меня на самые безрассудные приключения. Но что же вы, присаживайтесь. Я покажу вам свою работу, свою карту.^Географист вытащил огромный свиток и раскатал его по столу.');
		end;
	end;
	phr = {
		{'Меня интересует местность вокруг горы.', 'К сожалению, звери и монстры не дают мне проходу, но в свой телескоп я немного увидел и зарисовал основные места. Сначала за трактиром идёт кукурузное поле, которое примыкает к чёрному лесу покрывающему предгорья. С высотой лес сходит на нет и становятся видны какие-то развалины, трактирщик утверждает что это заброшенный город гномов. За развалинами начинается ледник, который сковал льдом всю вершину горы за исключеним кратера. Ха, а вы и не знали что это вулкан? Но Чёрная гора уже давно не извергалась, будьте спокойны. Дымится только немного.'};
		{'Спасибо за сведенья. Прощайте.', function() p '-- Если вернетесь с Чёрной горы, то расскажите что там интересного!'; walkout(); end;};
	};
};

room {
	nam = 'Кукурузное поле';
	pic = 'pics/03.png';
	title = false;
	dsc = 'Сразу за таверной начиналось кукурузное поле.';
	obj = {'Кукуруза', 'Колодец'};
	way = {'Трактир', 'Чёрный лес'};
	onexit = function(s, w)
		if w^'Чёрный лес' and seen 'Кукуруза' then
			p('И '..name..' уже почти выбрался с поля, когда его ноги захлестнули жесткие стебли проклятой кукурузы. А толстый початок заглушил крик. Теперь на кукурузном поле появилось новое пугало.^^Но ещё один волшебник прознал про Камень Могущества.');
			drop 'Оружие';
			place 'Пугало';
			die = die + 1;
			walkin 'Вопрос';
		end;
	end;
};

room {
	nam = 'Чёрный лес';
	pic = 'pics/04.png';
	title = false;
	onenter = function()
		if disabled 'Пивцы крови' and disabled 'Кентавры' then
			local i = rnd(2);
			if i == 1 then
				enable 'Пивцы крови';
			else
				enable 'Кентавры';
			end;
		end;
		if class == 'друид' then
			enable 'Дуб';
		end;
	end;
	dsc = 'В чёрном лесу сумрачно и белесый туман расползается между узловатых стволов деревьев.';
	obj = {'Пивцы крови', 'Кентавры', 'Дуб'};
	way = {'Кукурузное поле', 'Развалины'};
	onexit = function(s, w)
		if w^'Развалины' then
			if seen 'Пивцы крови' then
				p('О, бедный '..name..'! Он бежал как ветер, но пивцы крови всё-таки догнали его и, дружно хохоча, высосали всю его кровь.^^Но ещё один волшебник прознал про Камень Могущества.');
				drop 'Оружие';
				place 'Скелет';
				die = die + 1;
				walkin 'Вопрос';
			elseif seen 'Кентавры' then
				p 'Кентары преграждают путь дальше. Мимо них не пролезешь!';
				return false;
			end;
			local i = rnd(2);
			if i == 1 then
				golem = 'каменный';
			elseif i == 2 then
				golem = 'кирпичный';
			elseif i == 3 then
				golem = 'железо-бетонный';
			end;
		end;
	end;
};

room {
	nam = 'Развалины';
	pic = 'pics/05.png';
	title = false;
	dsc = 'Вокруг развалины некогда величественного города.';
	obj = {'Голем'};
	way = {'Чёрный лес', 'Ледник'};
	onexit = function(s, w)
		if w^'Ледник' and seen 'Голем' then
			p 'Голем преграждает путь дальше в горы.';
			return false;
		end;
	end;
};

room {
	nam = 'Ледник';
	pic = 'pics/06.png';
	title = false;
	onenter = function()
		if disabled 'Йети' and disabled 'Червь' then
			local i = rnd(2);
			if i == 1 then
				enable 'Йети';
			else
				enable 'Червь';
			end;
		end;
	end;
	dsc = 'Вокруг снег и лёд. Ледяной ветер дует с вершины.';
	obj = {'Йети', 'Червь'};
	way = {'Развалины', 'Кратер'};
	onexit = function(s, w)
		if seen 'Червь' then
			p('О, '..name..', ужасный ледяной червь настиг его, откусил ему глаз и обглодал со всех сторон.^^Но ещё один волшебник прознал про Камень Могущества.');
			drop 'Оружие';
			place 'Скелет2';
			die = die + 1;
			walkin 'Вопрос';
		elseif seen 'Йети' then
			if w^'Развалины' then
				p '-- Беги, беги. Мелкий колдунишка. Я подожду тебя тут! -- Кричал вдогонку Йети.';
			else
				p 'Огромный йети преграждает путь.';
				return false;
			end;
		end;
	end;
};

room {
	nam = 'Кратер';
	pic = 'pics/07.png';
	title = false;
	onenter = function()
		p('И вот '..name..' достиг вершины горы и спустился в кратер.');
	end;
	dsc = 'В кратере желтый дым и пар от магмы в центре застилали солнечный свет. Черные зловещие скалы торчали со всех сторон.';
	obj = {'Камень', 'Географист2', 'Кости'};
	way = {path {'Ледник', 'Конец'}};
};

room {
	nam = 'Конец';
	pic = 'pics/01.png';
	title = false;
	noinv = true;
	dsc = function()
		p('И вот '..name..' добрался до Камня Могущества и смог избежать его ловушки. И даже вернулся целый и невредимый в свою башню. В отличие от '..die..' волшебников, чьи кости остались лежать на склонах Чёрной горы.^^Получены достижения:^');
		local i = 1;
		for i = 1, #achiv do
			p(achiv[i]..'^');
		end;
		p('^Это была игра на Паровозик 2018 от Irremann. Спасибо за прохождение.');
	end;
};

--стальная, каменная, огненная, окровавленный
